//+----------------------------------------------------------------------------+
//|                                                           b-Positions.mqh  |
//|                                                      . aka KimIV  |
//|                                                       http://www.kimiv.ru  |
//|                                                                            |
//|  28.10.2006       .                    |
//+----------------------------------------------------------------------------+

// ExistPosByMN             -    
// ExistPositions           -  
// GetAmountLotFromOpenPos  -    
// GetIndexLastPos          -      -1
// GetMaxLotFromOpenPos     -      
// GetMinLotFromOpenPos     -      
// GetProfitOpenPosInCurrency       
// GetProfitOpenPosInPoint  -      
// isCloseLastPosByStop     -      
// isCloseLastPosByTake     -      
// isLossLastPos            -    
// NumberOfBarLastPos       -       -1
// NumberOfLossPosToday     -   ,  
// NumberOfPositions        -  
// SecondsAfterCloseLastPos -      
// SecondsAfterOpenLastPos  -      

//+----------------------------------------------------------------------------+
//|                                  |
//|  :                                                                |
//|    mn  - MagicNumber              (-1 -  )                       |
//+----------------------------------------------------------------------------+
bool ExistPosByMN(int mn=-1) {
  int i, k=OrdersTotal();

  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol()) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (mn<0 || OrderMagicNumber()==mn) return(True);
        }
      }
    }
  }
  return(False);
}

//+----------------------------------------------------------------------------+
//|                                          |
//|  :                                                                |
//|    sym -   ("" -  )                    |
//|    op  -                  (-1 -  )                     |
//|    mn  - MagicNumber              (-1 -  )                       |
//+----------------------------------------------------------------------------+
bool ExistPositions(string sym="", int op=-1, int mn=-1) {
  int i, k=OrdersTotal();

  if (sym=="") sym=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sym) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) return(True);
          }
        }
      }
    }
  }
  return(False);
}

//+----------------------------------------------------------------------------+
//|                                         |
//|  :                                                                |
//|    sym -   ("" -  )                    |
//|    op  -                  (-1 -  )                     |
//|    mn  - MagicNumber              (-1 -  )                       |
//+----------------------------------------------------------------------------+
double GetAmountLotFromOpenPos(string sym="", int op=-1, int mn=-1) {
  double l=0;
  int    i, k=OrdersTotal();

  if (sym=="") sym=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sym) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              l+=OrderLots();
            }
          }
        }
      }
    }
  }
  return(l);
}

//+----------------------------------------------------------------------------+
//|        -1                       |
//|  :                                                                |
//|    sym -   ("" -  )                    |
//|    op  -                  (-1 -  )                     |
//|    mn  - MagicNumber              (-1 -  )                       |
//+----------------------------------------------------------------------------+
int GetIndexLastPos(string sym="", int op=-1, int mn=-1) {
  datetime oot;
  int      i, k=OrdersTotal(), r=-1;

  if (sym=="") sym=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sym) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              if (oot<OrderOpenTime()) {
                oot=OrderOpenTime();
                r=i;
              }
            }
          }
        }
      }
    }
  }
  return(r);
}

//+----------------------------------------------------------------------------+
//|                           |
//|  :                                                                |
//|    sym -   ("" -  )                    |
//|    op  -                  (-1 -  )                     |
//|    mn  - MagicNumber              (-1 -  )                       |
//+----------------------------------------------------------------------------+
double GetMaxLotFromOpenPos(string sym="", int op=-1, int mn=-1) {
  double l=0;
  int    i, k=OrdersTotal();

  if (sym=="") sym=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sym) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              if (l<OrderLots()) l=OrderLots();
            }
          }
        }
      }
    }
  }
  return(l);
}

//+----------------------------------------------------------------------------+
//|                            |
//|  :                                                                |
//|    sym -   ("" -  )                    |
//|    op  -                  (-1 -  )                     |
//|    mn  - MagicNumber              (-1 -  )                       |
//+----------------------------------------------------------------------------+
double GetMinLotFromOpenPos(string sym="", int op=-1, int mn=-1) {
  double l=0;
  int    i, k=OrdersTotal();

  if (sym=="") sym=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sym) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              if (l==0 || l>OrderLots()) l=OrderLots();
            }
          }
        }
      }
    }
  }
  return(l);
}

//+----------------------------------------------------------------------------+
//|                     |
//|  :                                                                |
//|    sym -   ("" -  )                    |
//|    op  -                  (-1 -  )                     |
//|    mn  - MagicNumber              (-1 -  )                       |
//+----------------------------------------------------------------------------+
double GetProfitOpenPosInCurrency(string sym="", int op=-1, int mn=-1) {
  double p=0;
  int    i, k=OrdersTotal();

  if (sym=="") sym=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sym && (op<0 || OrderType()==op)) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (mn<0 || OrderMagicNumber()==mn) {
            p+=OrderProfit()+OrderSwap();
          }
        }
      }
    }
  }
  return(p);
}

//+----------------------------------------------------------------------------+
//|                            |
//|  :                                                                |
//|    sym -   ("" -  )                    |
//|    op  -                  (-1 -  )                     |
//|    mn  - MagicNumber              (-1 -  )                       |
//+----------------------------------------------------------------------------+
int GetProfitOpenPosInPoint(string sym="", int op=-1, int mn=-1) {
  double p;
  int    i, k=OrdersTotal(), pr=0;

  if (sym=="") sym=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sym && (op<0 || OrderType()==op)) {
        if (mn<0 || OrderMagicNumber()==mn) {
          p=MarketInfo(sym, MODE_POINT);
          if (p==0) if (StringFind(sym, "JPY")<0) p=0.0001; else p=0.01;
          if (OrderType()==OP_BUY) {
            pr+=(Bid-OrderOpenPrice())/p;
          }
          if (OrderType()==OP_SELL) {
            pr+=(OrderOpenPrice()-Ask)/p;
          }
        }
      }
    }
  }
  return(pr);
}

//+----------------------------------------------------------------------------+
//|        .                      |
//|  :                                                                |
//|    sym -   ("" -  )                    |
//|    op  -                  (-1 -  )                     |
//|    mn  - MagicNumber              (-1 -  )                       |
//+----------------------------------------------------------------------------+
bool isCloseLastPosByStop(string sym="", int op=-1, int mn=-1) {
  datetime oct;
  double   ocp, osl;
  int      dg, i, j=-1, k=HistoryTotal();

  if (sym=="") sym=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
      if (OrderSymbol()==sym) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              if (oct<OrderCloseTime()) {
                oct=OrderCloseTime();
                j=i;
              }
            }
          }
        }
      }
    }
  }
  if (OrderSelect(j, SELECT_BY_POS, MODE_HISTORY)) {
    dg=MarketInfo(sym, MODE_DIGITS);
    if (dg==0) if (StringFind(sym, "JPY")<0) dg=4; else dg=2;
    ocp=NormalizeDouble(OrderClosePrice(), dg);
    osl=NormalizeDouble(OrderStopLoss(), dg);
    if (ocp==osl) return(True);
  }
  return(False);
}

//+----------------------------------------------------------------------------+
//|        .                      |
//|  :                                                                |
//|    sym -   ("" -  )                    |
//|    op  -                  (-1 -  )                     |
//|    mn  - MagicNumber              (-1 -  )                       |
//+----------------------------------------------------------------------------+
bool isCloseLastPosByTake(string sym="", int op=-1, int mn=-1) {
  datetime oct;
  double   ocp, otp;
  int      dg, i, j=-1, k=HistoryTotal();

  if (sym=="") sym=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
      if (OrderSymbol()==sym) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              if (oct<OrderCloseTime()) {
                oct=OrderCloseTime();
                j=i;
              }
            }
          }
        }
      }
    }
  }
  if (OrderSelect(j, SELECT_BY_POS, MODE_HISTORY)) {
    dg=MarketInfo(sym, MODE_DIGITS);
    if (dg==0) if (StringFind(sym, "JPY")<0) dg=4; else dg=2;
    ocp=NormalizeDouble(OrderClosePrice(), dg);
    otp=NormalizeDouble(OrderTakeProfit(), dg);
    if (ocp==otp) return(True);
  }
  return(False);
}

//+----------------------------------------------------------------------------+
//|      .                            |
//|  :                                                                |
//|    sym -   ("" -  )                    |
//|    op  -                  (-1 -  )                     |
//|    mn  - MagicNumber              (-1 -  )                       |
//+----------------------------------------------------------------------------+
bool isLossLastPos(string sym="", int op=-1, int mn=-1) {
  datetime oct;
  int      i, j=-1, k=HistoryTotal();

  if (sym=="") sym=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
      if (OrderSymbol()==sym) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              if (oct<OrderCloseTime()) {
                oct=OrderCloseTime();
                j=i;
              }
            }
          }
        }
      }
    }
  }
  if (OrderSelect(j, SELECT_BY_POS, MODE_HISTORY)) {
    if (OrderProfit()<0) return(True);
  }
  return(False);
}

//+----------------------------------------------------------------------------+
//|         -1.                  |
//|  :                                                                |
//|    sym -   ("" -  )                    |
//|    tf  -                 ( 0 -  )                 |
//|    op  -                  (-1 -  )                     |
//|    mn  - MagicNumber              (-1 -  )                       |
//+----------------------------------------------------------------------------+
int NumberOfBarLastPos(string sym="", int tf=0, int op=-1, int mn=-1) {
  datetime oot;
  int      i, k=OrdersTotal();

  if (sym=="") sym=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sym) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              if (oot<OrderOpenTime()) oot=OrderOpenTime();
            }
          }
        }
      }
    }
  }
  return(iBarShift(sym, tf, oot, True));
}

//+----------------------------------------------------------------------------+
//|     ,  .                |
//|  :                                                                |
//|    sym -   ("" -  )                    |
//|    op  -                  (-1 -  )                     |
//|    mn  - MagicNumber              (-1 -  )                       |
//+----------------------------------------------------------------------------+
int NumberOfLossPosToday(string sym="", int op=-1, int mn=-1) {
  datetime oct;
  int      i, k=HistoryTotal(), kp=0;

  if (sym=="") sym=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
      if (OrderSymbol()==sym) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              oct=OrderCloseTime();
              if (Year()==TimeYear(oct) && DayOfYear()==TimeDayOfYear(oct)) {
                if (OrderProfit()<0) kp++;
              }
            }
          }
        }
      }
    }
  }
  return(kp);
}

//+----------------------------------------------------------------------------+
//|    .                                            |
//|  :                                                                |
//|    sym -   ("" -  )                    |
//|    op  -                  (-1 -  )                     |
//|    mn  - MagicNumber              (-1 -  )                       |
//+----------------------------------------------------------------------------+
int NumberOfPositions(string sym="", int op=-1, int mn=-1) {
  int i, k=OrdersTotal(), kp=0;

  if (sym=="") sym=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sym) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) kp++;
          }
        }
      }
    }
  }
  return(kp);
}

//+----------------------------------------------------------------------------+
//|        .            |
//|  :                                                                |
//|    sym -   ("" -  )                    |
//|    op  -                  (-1 -  )                     |
//|    mn  - MagicNumber              (-1 -  )                       |
//+----------------------------------------------------------------------------+
datetime SecondsAfterCloseLastPos(string sym="", int op=-1, int mn=-1) {
  datetime oct;
  int      i, k=HistoryTotal();

  if (sym=="") sym=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
      if (OrderSymbol()==sym) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              if (oct<OrderCloseTime()) oct=OrderCloseTime();
            }
          }
        }
      }
    }
  }
  return(CurTime()-oct);
}

//+----------------------------------------------------------------------------+
//|        .            |
//|  :                                                                |
//|    sym -   ("" -  )                    |
//|    op  -                  (-1 -  )                     |
//|    mn  - MagicNumber              (-1 -  )                       |
//+----------------------------------------------------------------------------+
datetime SecondsAfterOpenLastPos(string sym="", int op=-1, int mn=-1) {
  datetime oot;
  int      i, k=OrdersTotal();

  if (sym=="") sym=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sym) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              if (oot<OrderOpenTime()) oot=OrderOpenTime();
            }
          }
        }
      }
    }
  }
  return(CurTime()-oot);
}
//+----------------------------------------------------------------------------+

